/* Enemy.h class file
 * Created: 5. August 1999
 * Last modified: 5. August 1999
 */


#define ARRAYSIZE 15 // size of name array

class Enemy
{
public:
  // constructor & deconstructor
  Enemy(char * s = "", int life = 0, int essence = 0);
  ~Enemy();

  // member functions
  char * retName();
  void setLP(int);
  int  retLP();
  void setEP(int);
  int  retEP();

  // member functions for combat
  int retCSkill();
  int retWSkill();
  int retDSkill();
  int retBPoints();

private:
  char name[ARRAYSIZE]; 
  int lp; // life points
  int ep; // essence points
  int cskill; // combat skill
  int wskill; // weapon skill
  int dskill; // defense skill
  int bpoints; // bonus points
};

Enemy :: Enemy(char * s, int life, int essence)
{
  strcpy(name, s);
  lp = life;
  ep = essence;
  cskill = 11;
  wskill = 3;
  dskill = 5;
  bpoints = 0;
}

Enemy :: ~Enemy()
{}

char * Enemy :: retName()
{
  return (name);
}

void Enemy :: setLP(int num)
{
  lp = lp + num;
}

int Enemy :: retLP()
{
  return (lp);
}

void Enemy :: setEP(int num)
{
  ep = ep + num;
}

int Enemy :: retEP()
{
  return (ep);
}

// ----------------------------------------------------------------
// COMBAT METHOD FUNCTIONS
// ----------------------------------------------------------------

int Enemy :: retCSkill()
{
  return cskill;
}

int Enemy :: retWSkill()
{
  return wskill;
}

int Enemy :: retDSkill()
{
  return dskill;
}
  
int Enemy :: retBPoints()
{
  return bpoints;
}
