#include "Node.h"

class List
{
public:
  // member functions
  List();  // constructor
  ~List(); // destructor

  void insert(char [], int);
  void remove(char []);
  void print();
  int  search(char []);

private:
  Node *list_ptr;
  Node *head;
  Node *tail;
  int numitems;
};

List :: List()
{
  list_ptr = NULL;
  head = NULL;
  tail = NULL;
  numitems = 0;
}

List :: ~List()
{
}

void List :: insert(char name[], int num)
{
  Node *newnode = new Node(name, num);
  Node *search_ptr;
  search_ptr = head;
  int found = 0;

  if (head != NULL)
  {
    if ((*head).retNext() == NULL && !strcmp((*search_ptr).retItemName(), name))
    {
      found = 1;
      (*search_ptr).setNumItem(1);
      numitems++;
    }

    while((*search_ptr).retNext() != NULL && found == 0)
    {
      if (!strcmp((*search_ptr).retItemName(), name))
      {
	found = 1;
	(*search_ptr).setNumItem(1);
	numitems++;
      }
      else
	search_ptr = (*search_ptr).retNext();
    }
      /* check last item in list now */
      if (search_ptr != head)
      {
        if (!strcmp((*search_ptr).retItemName(), name))
        {
	  found = 1;
	  (*search_ptr).setNumItem(1);
	  numitems++;
        }
      }
  }

  if (found == 0)
  {
    if (head == NULL)
    {
      head = newnode;
      list_ptr = newnode;
      tail = newnode;
      numitems++;
    }
    else
    {
      (*list_ptr).setNext(newnode); // point previous Node's next to
                                    // newnode
      list_ptr = newnode;
      tail = newnode;
      numitems++;
    }
  }
}

void List :: remove(char string[])
{
  // declare variables
  int found = 0; // set to 1 if node is found
  Node * temp;

  list_ptr = head; // point to beginning of list

  // this is necessary in case there are no nodes in the list
  if (numitems <= 1)
  { 
    temp = NULL;
  }
  else
  {
    temp = (*list_ptr).retNext();
  }

  if (head == NULL)
    found = 4;
  else
  {
    while((*list_ptr).retNext() != NULL && found == 0)
    {
      if (!strcmp((*head).retItemName(), string))
        found = 3;
      else if (!strcmp((*temp).retItemName(), string))
        found = 2;
      else
      {
        list_ptr = (*list_ptr).retNext(); // point to next node
        if ( (*list_ptr).retNext() != NULL )
          temp = (*list_ptr).retNext(); // points to list_ptr's new place
        if ( (*temp).retNext() == NULL && !strcmp((*temp).retItemName(), string))
          found = 1;
      }
    }
    if (!strcmp( (*head).retItemName(), string))
      found = 3;
  }

  if (found == 4)
    cout << "You have nothing to drop." << endl;
  else if (found == 3)
  {
    temp = head;

    if ( (*temp).retNumItem() > 1)
    {
      (*temp).setNumItem(-1);
      numitems = numitems - 1;
    }
    else
    {
      if ( (*temp).retNext() != NULL )
        head = (*temp).retNext();
      else
      {
        head = NULL;
        tail = NULL;
      }

      numitems = numitems - 1;
      delete temp;
    }
  }
  else if (found == 2)
  {
    if ( (*temp).retNumItem() > 1)
    {
      (*temp).setNumItem(-1);
      numitems = numitems - 1;
    }
    else
    {
      if ( (*temp).retNext() == NULL )
      {
        tail = list_ptr;  // not sure if this is right
        list_ptr = head;
        (*head).setNext(NULL);
      }
      else
        (*list_ptr).setNext((*temp).retNext());

      numitems = numitems - 1;
      delete temp;
    }
  }
  else if (found == 1) // check the last item in the list & delete
  {

    if ( (*temp).retNumItem() > 1)
    {
      (*temp).setNumItem(-1);
      numitems = numitems - 1;
    }
    else
    {
      (*list_ptr).setNext(NULL);
      tail = list_ptr;
      numitems = numitems - 1;
      delete temp;
    }
  }
  else
   cout << ""; // cout << "Couldn't find that item." << endl;
}


void List :: print()
{
  int i = 0; // i is temp value to prevent infinite looping

//  cout << "Number of items: " << numitems << endl << endl;

  if (head == NULL)
    cout << "You are carrying nothing." << endl;
  else if ((*head).retNext() == NULL)
  {
    cout << (*head).retItemName() << " (" << (*head).retNumItem() <<
    ")" << endl;
  }
  else
  {
    list_ptr = head; // initialize list_ptr to start at beginning
    while ( ((*list_ptr).retNext() != NULL) && (i < 15))
    {
      cout << (*list_ptr).retItemName() << " (" <<
      (*list_ptr).retNumItem() << ")" << endl; // print name
      list_ptr = (*list_ptr).retNext(); // point to next Node
      i++;
    }
    cout << (*list_ptr).retItemName() << " (" << 
    (*list_ptr).retNumItem() << ")" << endl; // print last item in list
  }
}


int List :: search(char string[])
{
  int found = 0; // if string is found, set to 1
  list_ptr = head; // set list_ptr to front of list

  if (head == NULL)
    cout << "";    //cout << "The list is empty." << endl;
  else
  {
    // while the end of the list hasn't been reached or the item hasn't
    // been found, keep looping
    while((*list_ptr).retNext() != NULL && found == 0)
    { // if the item is found
      if (!strcmp((*list_ptr).retItemName(), string))
        found = 1;
      else  // else, keep searching
        list_ptr = (*list_ptr).retNext(); // point to next node
    }
    // if case is for last element in list which wasn't checked in
    // the while loop
    if (!strcmp( (*list_ptr).retItemName(), string))
      found = 1;
  }
/*
  if (found == 0)
    cout << "The item was not found." << endl;
  else
    cout << "The item was found." << endl;
*/
  return found;
}
