/* Second attempt at a role-playing game
   Coding began 1. February 1999
   Last modified: 29. July 1999
*/

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <string.h>

#include "List.h"
#include "Myr.h"
#include "Enemy.h"
#include "Room.h"

#include "get_random.h"
#include "get_int.h"
#include "get_int_bound.h"
#include "tutorial.h"
#include "general.h"

#include "room0.h"
#include "room1.h"
#include "room2.h"
#include "room3.h"
#include "room4.h"
#include "room5.h"
#include "room6.h"
#include "room7.h"
#include "room8.h"
#include "room9.h"
#include "room10.h"
#include "room11.h"
#include "room12.h"
#include "room13.h"
#include "room14.h"
#include "room15.h"
#include "room16.h"
#include "room17.h"
#include "room18.h"
#include "room19.h"
#include "room20.h"
#include "room21.h"
#include "room22.h"

#define MAXROOMS 30

int menu();
void engine(Myr &, Room [], int);
void (*pt2rm[30])(Myr &, Room [], int &); // array of pointers to rooms
void initRooms(Room [], Myr); // initialize rooms
void initSo(Myr &); // initialize Sorcerer
void initEl(Myr &); // initialize Elementalist
void initPs(Myr &); // initialize Psychomancer
void initSp(Myr &); // initialize Spirit Mage


void main()
{
  // declare variables
  int onechoice, choice = 0;
  Myr wytch(50, 30, 0); // constructor of character
  Room rooms[MAXROOMS]; // array to hold the rooms

  // initialize the rooms' numbers
  for (int i = 0; i < MAXROOMS; i++)
    rooms[i].rmnum(i);

  // body of main()

  onechoice = menu();

  if (onechoice == 2)
    tutorial();

  if (onechoice != 3)
  {
  cout << "Choose the Circle of Magic you wish to learn" << endl << endl;

  cout << "1. Sorcery" << endl
       << "2. Elementalism" << endl
       << "3. Psychomancy" << endl
       << "4. Spirit" << endl << endl;

  cout << "Now choose your destiny > ";	

  get_int(choice, 1, 4);  

  switch(choice)
  {
  case 1 : initSo(wytch);
           break; // declare Sorcery
  case 2 : initEl(wytch);
           break; // declare Elementalism
  case 3 : initPs(wytch);
           break; // declare Psychomany
  case 4 : initSp(wytch);
           break; // declare Spirit
  default : cout << "Good-bye." << endl << endl;
  }
  } // end of if (choice != 3)
 
  engine(wytch, rooms, onechoice);
}

int menu()
{
  int firstchoice;

  cout << "-----------------------------------" <<
  endl << "| Psychomancer Demo (Version 0.95) |" <<
  endl << "-----------------------------------" <<
  endl <<
  endl << "----------------------" <<
  endl << " 1. Play the game "<<
  endl << " 2. Read the tutorial "<<
  endl << " 3. Restore game " <<
  endl << "----------------------" <<
  endl << "> ";

  get_int(firstchoice, 1, 3);

  return firstchoice;
}

void engine(Myr & wytch, Room rooms[], int restore)
{
  int setroom = 0;
  char blah[4] = "";

  initRooms(rooms, wytch);  // initialize the fp array for rooms
  
  if (restore == 3)
    restoregame(setroom, wytch, rooms, blah); // restore game settings

  while (setroom < 100)
  {
    rooms[setroom].rm(); // gives initial description of room
    (*pt2rm[setroom])(wytch, rooms, setroom);

/*    cout << "What room now? ";
      cin >> setroom;
      setroom = rooms[setroom].retrm();
*/

  }
}

void initRooms(Room rooms[], Myr wytch)
{
  pt2rm[0] = room0;
  //rooms[0].setExits(0, 1, 1, 1, 1); //door, lock, closed, next_room, misc
    // 0th door, locked, closed, next room, and it's not destroyed yet
  /* exit 0 was changed to exit 3 because of an odd error where the door
     kept unlocking itself for some odd reason */
    rooms[0].setExits(3, 1, 1, 1, 1);
    rooms[0].setExits(1, 0, 1, 15, 1); // misc is if door is hidden
    rooms[0].setMiscvar(0, 0); // if lights are on/off
    rooms[0].setMiscvar(2, 1); // a fix to lock the front door again
    rooms[0].insertItem("stone", 1); // add a stone to the room
  pt2rm[1] = room1;
    rooms[1].setExits(1, 0, 1, 2, 0); // north door
    rooms[1].setMiscvar(0, 0); // first position in array-if been in room
    if (wytch.retCircle() == 4)
      rooms[1].insertItem("iron key", 1); // add iron key for Spirit Mage
  pt2rm[2] = room2;
    rooms[2].setExits(0, 0, 1, 3, 0); // unlocked, closed door to room 3
  pt2rm[3] = room3;
    rooms[3].setMiscvar(0, 0); // the book hasn't been read yet
    rooms[3].insertItem("scroll", 1);
  pt2rm[4] = room4;
    rooms[4].setExits(0, 1, 1, 7, 0); // locked & closed door to room 6 
  pt2rm[5] = room5;
  pt2rm[6] = room6;
    rooms[6].setExits(0, 1, 1, 100, 1); // actually this is a chest
    rooms[6].setMiscvar(0, 1); // chest hasn't been searched yet
    rooms[6].insertItem("blue potion", 1); // healing potion
    rooms[6].insertItem("red potion", 1); // essence potion
    rooms[6].insertItem("red potion", 1); // essence potion
    rooms[6].insertItem("green potion", 1); // poison
    rooms[6].insertItem("clear potion", 1); // Crystal Pepsi
    if (wytch.retCircle() == 2)
    {
      rooms[6].insertItem("scroll", 1); // scroll for Elementalist
      rooms[6].insertItem("empty flask", 1);
    }
  pt2rm[7] = room7;
    rooms[7].setExits(0, 0, 0, 0, 0);
    rooms[7].setExits(1, 0, 0, 18, 0);
  pt2rm[8] = room8;
    rooms[8].setExits(0, 0, 1, 3, 0); // unlocked, closed door to room 3
  pt2rm[9] = room9;
    rooms[9].setExits(0, 1, 1, 16, 0);
  pt2rm[10] = room10;
  pt2rm[11] = room11;
  pt2rm[12] = room12;
    rooms[12].insertItem("amulet", 1);
  pt2rm[13] = room13;
    rooms[13].insertItem("candle", 1);
  pt2rm[14] = room14;
    rooms[14].setExits(0, 1, 1, 15, 0); // locked, closed door to room 15
  pt2rm[15] = room15;
    rooms[15].setMiscvar(0, 1);
    rooms[15].insertItem("tinderbox", 1);
    rooms[15].insertItem("staff", 1);
    rooms[15].insertItem("healing potion", 1);
    rooms[15].insertItem("essence potion", 1);
  pt2rm[16] = room16;
  pt2rm[17] = room17;
  pt2rm[18] = room18;
    rooms[18].insertItem("stone", 100);
    rooms[0].setExits(0, 0, 1, 7, 1); // misc is if door is hidden
  pt2rm[19] = room19;
  pt2rm[20] = room20;
  pt2rm[21] = room21;
    if (wytch.retCircle() == 4)
      rooms[21].setExits(0, 0, 0, 16, 0); // can still go down for Spirit
    else
      rooms[21].setExits(0, 1, 1, 16, 0);
  pt2rm[22] = room22;
}

void initSo(Myr & wytch)
{
  wytch.setCircle(1); 
  wytch.addSpell("Illuminate", 2); 
  wytch.addSpell("Unlock", 2);
  wytch.addSpell("Translate", 4);
}

void initEl(Myr & wytch)
{
  wytch.setCircle(2); 
  wytch.addSpell("Illuminate", 2);
  wytch.addSpell("Element Talk", 5);
  wytch.addSpell("Fire Spear", 7);
}

void initPs(Myr & wytch)
{
  wytch.setCircle(3); 
  wytch.addSpell("Illuminate", 2);
  wytch.addSpell("Sense", 3);
  wytch.addSpell("Mental Key", 4);
  wytch.addSpell("History", 5);
}

void initSp(Myr & wytch)
{
  wytch.setCircle(4); 
  wytch.addSpell("Illuminate", 2);
  wytch.addSpell("Create BloodStone", 3);
  wytch.addSpell("Spirit Talk", 10);
}


