/* room13.h - Cylindrix Prayer Room 
 * Created: 2. August 1999 
 * Last modified: 5. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init13(char string[]);
void desc13();
void look13(Room [], char [], char [], char []);
void cast13(Myr &, char [], char []);
void take13(Myr &, Room [], char [], char []);
void move13(char [], char []);

void room13(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  cout << 
  endl << "Even without a Sense spell, you can detect an aura of great " <<
  endl << "goodness and peace permeating the room." << endl;
  wytch.modLife(1); // LP taken away due to evil presence
  desc13();


  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
    {
      cout << "You leave the prayer room." << endl;
      rooms[11].setPrevRoom(13);
      setroom = 11;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
      cout << "You can't go in that direction." << endl;
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look13(rooms, token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast13(wytch, token2, token3);
    }
    else if (!strcmp(token, "get") || !strcmp(token, "take"))
      take13(wytch, rooms, token2, token3);
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "pray") || !strcmp(token, "kneel"))
    {
      cout << "You kneel at the altar and pray to Cylindrix for a few " <<
      endl << "minutes.  You feel a great warmth come over you as your" << 
      endl << "body is healed.  You make your final blessing and stand." << 
      endl;
      wytch.modLife(5);
    }
    else if (!strcmp(token, "move"))
      move13(token2, token3);
    else if (!strcmp(token, "light") && !strcmp(token2, "candle"))
    {
      cout << "While that is a good idea, you feel that this isn't exactly"<<
      endl << "the proper time or place to light the candle." << endl;
    }
    else if (!strcmp(token, "stand"))
      cout << "You are already standing!" << endl;
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[13].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init13(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init13(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc13()                                              *
 * Gives the room description                            *
 ********************************************************/
void desc13()
{
  cout <<
  endl << "You are in a small, light prayer room.  Tall candelabras act as" <<
  endl << "sentinels on each side of a low altar near the center of the "<<
  endl << "room.  A long tapestry decorates the back wall of the small "<<
  endl << "room." <<
  endl;
}


/*********************************************************
 * look13()                                             *
 ********************************************************/
void look13(Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "tapestry") || !strcmp(token2, "wall"))
  {
    if (rooms[3].getMiscvar(0) == 0)
    {
      cout << "The tapestry bears a large complex Q-shaped symbol on it." <<
      endl << "You wonder about the significance of it in this room." << endl;
    }
    else
    {
      cout << "The long tapestry is fairly simple except for the complex"<<
      endl << "Q-design which you recognize as the symbol of Angwyn." << endl;
    }
  }
  else if (!strcmp(token2, "candelabra") || !strcmp(token2, "candelabras"))
  {
    cout << "Two lit candelabras stand on each side of the altar." << endl;
  }
  else if (!strcmp(token2, "altar"))
  {
    if (rooms[13].searchItem("candle") != 0)
    {
      cout << "The altar has a cloth draped over it, embossed with the "<<
      endl << "symbol of Cylindrix, the Immortal of Light.  There is an"<<
      endl << "unlit candle on the altar." << endl;
    }
    else
    {
      cout << "The altar has a cloth draped over it, embossed with the" <<
      endl << "symbol of Cylindrix, the Immortal of Light." << endl;
    }
  }
  else if (!strcmp(token2, "cloth"))
  {
    cout << "The cloth is made of a white wine silk, apparently old from" <<
    endl << "the layer of dust on it.  The symbol of Cylindrix is stitched"<<
    endl << "into the fabric." << endl;
  }
  else if (!strcmp(token2, "symbol") || !strcmp(token2, "symbols"))
  {
    cout << "You see two symbols in this room; an intricate Q-shaped" <<
    endl << "symbol on the tapestry hanging on the wall, and the " <<
    endl << "symbol of Cylindrix which looks like a fancy x encircled"<<
    endl << "by a capital C."<< endl;
  }
  else if (!strcmp(token2, "candle") || !strcmp(token3, "candle"))
  {
    if (rooms[13].searchItem("candle") != 0)
    {
      cout << "There is an unlit candle centered on the altar. From "<<
      endl << "what you remember of the legends of Cylindrix, a lit candle"<<
      endl << "is one of the symbols of the Immortal of Light." << endl;
    }
    else
      cout << "You don't see a candle here." << endl;
  }
  else if (!strcmp(token2, "room"))
    desc13();
  else
    desc13();
}


/*********************************************************
 * cast13()                                             *
 ********************************************************/
void cast13(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Sense"))
    {
      cout << "You sense a great deal of Goodness radiating from this room."<<
      endl;
    }
    else
    {
      cout << "While you got in some good practice, your spell wasn't " <<
      endl << "necessarily useful here." << endl;
    }
  }
}

void take13(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "candle") || !strcmp(token3, "candle"))
  { 
    if (rooms[13].searchItem("candle") != 0)
    {
    cout << "You pick up the candle and put it into your pack." << endl;
    wytch.insertInv("candle", 1);
    rooms[13].removeItem("candle");
    }
    else
      cout << "You don't see any candle here." << endl;
  }
  else if (!strcmp(token2, "candelabra") || !strcmp(token2, "candelabras"))
    cout << "You don't need a candelabra." << endl;
  else if (!strcmp(token2, "tapestry"))
  {
    cout << "You don't have the space in your backpack to carry that " <<
    endl << "tapestry around with you." << endl;
  }
  else if (!strcmp(token2, "altar"))
  {    
    cout << "Come on, get serious!  Even if there was a way to break the" <<
    endl << "altar away from the floor, you certainly don't have the" <<
    endl << "strength to lug an entire altar around for the rest of the game."
  <<endl;
  }
  else if (!strcmp(token2, "cloth"))
  {
    cout << "You don't seen any real reason to carry around the cloth, so"<<
    endl << "you decide against taking it with you." << endl;
  }
  else
    cout << "What are you trying to get?" << endl;
}

void move13(char token2[], char token3[])
{
  if (!strcmp(token2, "tapestry"))
  {
    cout << "You look behind the tapestry and find a secret hidden latch" <<
    endl << "which will open up the door to the minotaur's lair...oh, wait"<<
    endl << "wrong game...Since this isn't King's Quest 6, you will have"<<
    endl << "to settle for seeing nothing behind the tapestry except a "<<
    endl << "boring stone wall." << endl;
  }
  else if (!strcmp(token2, "altar") || !strcmp(token3, "altar"))
  {
    cout << "You put your weight and strength behind pushing the altar" <<
    endl << "but nothing happens.  The altar hasn't budged at all." << endl;
  }
  else if (!strcmp(token2, "cloth"))
    cout << "You don't need to move the cloth." << endl;
  else if (!strcmp(token2, "candelabra") || !strcmp(token2, "candelabras"))
    cout << "You will get no use from moving the candelabras." << endl;
  else if (!strcmp(token2, "candle"))
    cout << "How about just taking it instead?" << endl;
  else
    cout << "";
}
